;CodeVisionAVR C Compiler V1.24.2c Professional
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 16,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test2.vec"
	.INCLUDE "test2.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.3 Evaluation
;       4 Automatic Program Generator
;       5  Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : Test-LCD
;       9 Version : 6
;      10 Date    : 13/05/2010
;      11 Author  : Hoguet Marchand
;      12 Company : Thierry
;      13 Comments: Programmation Borne d'criture
;      14 
;      15 
;      16 Chip type           : ATmega8535
;      17 Program type        : Application
;      18 Clock frequency     : 16,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 128
;      22 *****************************************************/
;      23 
;      24 #include <mega8535.h>      
;      25 /* the LCD module is connected to PORTC */
;      26 #asm
;      27     .equ __lcd_port=0x15
    .equ __lcd_port=0x15
;      28 #endasm

;      29 
;      30 /* now you can include the LCD Functions */
;      31 #include <lcd.h>
;      32 #include <delay.h>     // pour la fonction delay_ms();
;      33 #include <stdio.h>     // pour la fonction sprintf();
;      34 
;      35 #define CTS     PIND.4
;      36 #define BUZZER  PINA.7
;      37 
;      38 // Declare your global variables here
;      39 
;      40 unsigned char tampon[20], Temps1[20], Identifiant[8];
_tampon:
	.BYTE 0x14
_Temps1:
	.BYTE 0x14
_Identifiant:
	.BYTE 0x8
;      41 unsigned char trame, Statut, Information;
;      42 unsigned char Temps, Seconde, Minute, Heure;
;      43 
;      44 
;      45 void USART_Transmit( unsigned char data )
;      46 {

	.CSEG
_USART_Transmit:
;      47 /* Wait for empty transmit buffer */
;      48 while ( !( UCSRA & (0x20)) ) // Test de UDRE bit 5
_0x3:
	SBIS 0xB,5
;      49 ;
	RJMP _0x3
;      50 /* Put data into buffer, sends the data */
;      51 UDR = data;
	LD   R30,Y
	OUT  0xC,R30
;      52 }
	ADIW R28,1
	RET
;      53 
;      54 unsigned char USART_Receive( void )
;      55 {
_USART_Receive:
;      56 /* Wait for data to be received */
;      57 while ( !(UCSRA & 0x80) ) // Test de RXC bit7
_0x6:
	SBIS 0xB,7
;      58 ;
	RJMP _0x6
;      59 /* Get and return received data from buffer */
;      60 return UDR;
	IN   R30,0xC
	RET
;      61 }
;      62 
;      63 // Permet de vrifier le Statut de la carte  
;      64 
;      65 int VerifStatut (void)
;      66 {
_VerifStatut:
;      67 	int Presence;
;      68  	while(CTS==1);     //Attente que l'entre CTS soit active ( 0)
	RCALL __SAVELOCR2
;	Presence -> R16,R17
_0x9:
	SBIC 0x10,4
	RJMP _0x9
;      69         trame='S';        //ou 0x53 : permet de vrifier le statut
	LDI  R30,LOW(83)
	RCALL SUBOPT_0x0
;      70         USART_Transmit(trame);
;      71         Statut = USART_Receive();
;      72     
;      73     	if(Statut==0x96)      //Bit d'identification de la carte
	LDI  R30,LOW(150)
	CP   R30,R5
	BRNE _0xC
;      74         {
;      75             Presence=1;
	__GETWRN 16,17,1
;      76             sprintf(tampon,"Lecture  ");
	RCALL SUBOPT_0x1
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x9D
;      77             lcd_gotoxy(0,2);
;      78             lcd_puts(tampon);
;      79         }
;      80         else
_0xC:
;      81         {
;      82             Presence=0;
	__GETWRN 16,17,0
;      83             sprintf(tampon,"Pas Carte");
	RCALL SUBOPT_0x1
	__POINTW1FN _0,10
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
_0x9D:
	RCALL _sprintf
	ADIW R28,4
;      84             lcd_gotoxy(0,2);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x3
;      85             lcd_puts(tampon);
	RCALL _lcd_puts
;      86         }
;      87     return Presence;   
	__GETW1R 16,17
	RCALL __LOADLOCR2P
	RET
;      88 }
;      89                     
;      90 void Recoit_UID (void)
;      91 {
_Recoit_UID:
;      92     int i;
;      93     unsigned char car;;
	RCALL __SAVELOCR3
;	i -> R16,R17
;	car -> R18
;      94     i=0;
	__GETWRN 16,17,0
;      95     while(CTS==1);
_0xE:
	SBIC 0x10,4
	RJMP _0xE
;      96     trame='U',     //ou 0x55 : permet de lire l'UID
	LDI  R30,LOW(85)
	RCALL SUBOPT_0x0
;      97     USART_Transmit(trame);
;      98     Statut = USART_Receive();
;      99     
;     100     while(i<=6)     // 6 pour les MIFARE 1k/4k card types
_0x11:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x13
;     101     {
;     102         car = USART_Receive();
	RCALL _USART_Receive
	MOV  R18,R30
;     103         Identifiant[i]=car;
	__GETW2R 16,17
	SUBI R26,LOW(-_Identifiant)
	SBCI R27,HIGH(-_Identifiant)
	ST   X,R18
;     104         i++;
	__ADDWRN 16,17,1
;     105     }
	RJMP _0x11
_0x13:
;     106 } 
	RCALL __LOADLOCR3
	ADIW R28,3
	RET
;     107 
;     108 // Mise en place de l'interruption interne 2000 KHz permettant d'tablir le temps
;     109 
;     110 interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;     111 {  
_timer1_compa_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;     112 	Temps++;
	INC  R7
;     113 	if (Temps>=100) 
	LDI  R30,LOW(100)
	CP   R7,R30
	BRLO _0x14
;     114 	{
;     115 		Temps=0;
	CLR  R7
;     116 		Seconde++;
	INC  R8
;     117 		if(Seconde>=10) 
	LDI  R30,LOW(10)
	CP   R8,R30
	BRLO _0x15
;     118 		{
;     119 			Seconde=0;
	CLR  R8
;     120 			Minute++;
	INC  R9
;     121 			if(Minute>=3)
	LDI  R30,LOW(3)
	CP   R9,R30
	BRLO _0x16
;     122 			{
;     123 				Minute=0;
	CLR  R9
;     124 				Heure++;
	INC  R10
;     125 				if(Heure>=99)
	LDI  R30,LOW(99)
	CP   R10,R30
	BRLO _0x17
;     126 				{
;     127 					Heure=0;
	CLR  R10
;     128 				};
_0x17:
;     129 			};
_0x16:
;     130 		};
_0x15:
;     131 	}; 
_0x14:
;     132 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     133 
;     134 void Horloge(void)
;     135 {
_Horloge:
;     136     sprintf(Temps1,"%2dh %2dmin %2ds", Heure, Minute, Seconde);
	RCALL SUBOPT_0x4
	__POINTW1FN _0,20
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R10
	RCALL SUBOPT_0x5
	MOV  R30,R9
	RCALL SUBOPT_0x5
	MOV  R30,R8
	RCALL SUBOPT_0x5
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
;     137     lcd_gotoxy(0,3);
	RCALL SUBOPT_0x2
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x6
;     138     lcd_puts(Temps1);
	RCALL SUBOPT_0x4
	RCALL _lcd_puts
;     139 }
	RET
;     140 
;     141 
;     142 //Remise  zro synchronise
;     143 interrupt [EXT_INT1] void ext_int1_isr(void)
;     144 {
_ext_int1_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;     145     Temps=0;
	RCALL SUBOPT_0x7
;     146     Seconde=0;
;     147     Minute=0;
;     148     Heure=0;
;     149 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     150 
;     151 
;     152 //Dclenchement  la detection d'une carte
;     153 interrupt [EXT_INT0] void ext_int0_isr(void) 
;     154 { 
_ext_int0_isr:
;     155 
;     156 }    
	RETI
;     157 
;     158 void EcritureTemps(int Borne)
;     159 {
_EcritureTemps:
;     160     int z;
;     161     
;     162     while(CTS==1);
	RCALL __SAVELOCR2
;	Borne -> Y+2
;	z -> R16,R17
_0x18:
	SBIC 0x10,4
	RJMP _0x18
;     163     trame='W';     //ou 0x57 : permet de lire l'UID
	LDI  R30,LOW(87)
	RCALL SUBOPT_0x8
;     164     USART_Transmit(trame);
;     165     
;     166     while(CTS==1);
_0x1B:
	SBIC 0x10,4
	RJMP _0x1B
;     167     trame=Borne*18;     //Ecriture  l'adresse du numro de borne
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	RCALL __MULW12
	RCALL SUBOPT_0x8
;     168     USART_Transmit(trame);
;     169     
;     170     while(CTS==1);
_0x1E:
	SBIC 0x10,4
	RJMP _0x1E
;     171     trame=0x00;     //Cl de scurit  choisir entre 0 et 31 sur les 5 premiers bits de l'octet
	CLR  R4
;     172     USART_Transmit(trame);
	RCALL SUBOPT_0x9
;     173     
;     174     for(z=0; z<4;z++)
	__GETWRN 16,17,0
_0x22:
	__CPWRN 16,17,4
	BRGE _0x23
;     175     {
;     176     	trame = Identifiant[z];
	LDI  R26,LOW(_Identifiant)
	LDI  R27,HIGH(_Identifiant)
	ADD  R26,R16
	ADC  R27,R17
	LD   R4,X
;     177     	USART_Transmit(trame);
	RCALL SUBOPT_0x9
;     178     }
	__ADDWRN 16,17,1
	RJMP _0x22
_0x23:
;     179     
;     180     while(CTS==1);
_0x24:
	SBIC 0x10,4
	RJMP _0x24
;     181     trame=Temps;
	MOV  R4,R7
;     182     USART_Transmit(trame);
	RCALL SUBOPT_0x9
;     183     
;     184     while(CTS==1);
_0x27:
	SBIC 0x10,4
	RJMP _0x27
;     185     trame=Seconde;
	MOV  R4,R8
;     186     USART_Transmit(trame);
	RCALL SUBOPT_0x9
;     187     
;     188     while(CTS==1);
_0x2A:
	SBIC 0x10,4
	RJMP _0x2A
;     189     trame=Minute;
	MOV  R4,R9
;     190     USART_Transmit(trame);
	RCALL SUBOPT_0x9
;     191     
;     192     while(CTS==1);
_0x2D:
	SBIC 0x10,4
	RJMP _0x2D
;     193     trame=Heure;
	MOV  R4,R10
;     194     USART_Transmit(trame);
	RCALL SUBOPT_0x9
;     195     
;     196     sprintf(trame, "");
	MOV  R30,R4
	RCALL SUBOPT_0xA
	__POINTW1FN _0,37
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xB
;     197     for(z=0;z<8;z++)
	__GETWRN 16,17,0
_0x31:
	__CPWRN 16,17,8
	BRGE _0x32
;     198     {
;     199     	while(CTS==1);
_0x33:
	SBIC 0x10,4
	RJMP _0x33
;     200     	USART_Transmit(trame);
	RCALL SUBOPT_0x9
;     201     }
	__ADDWRN 16,17,1
	RJMP _0x31
_0x32:
;     202     
;     203         sprintf(Information, "");
	MOV  R30,R6
	RCALL SUBOPT_0xA
	__POINTW1FN _0,38
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xB
;     204     	Information = USART_Receive();
	RCALL _USART_Receive
	MOV  R6,R30
;     205 
;     206     
;     207 }
	RCALL SUBOPT_0xC
	RET
;     208     
;     209 
;     210 void main(void)
;     211 {
_main:
;     212 // Declare your local variables here
;     213 
;     214 // Input/Output Ports initialization
;     215 // Port A initialization
;     216 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
;     217 // State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T 
;     218 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     219 DDRA=0xF0;
	LDI  R30,LOW(240)
	OUT  0x1A,R30
;     220 
;     221 // Port B initialization
;     222 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     223 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     224 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     225 DDRB=0x00;
	OUT  0x17,R30
;     226 
;     227 // Port C initialization
;     228 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
;     229 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
;     230 PORTC=0x00;
	OUT  0x15,R30
;     231 DDRC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;     232 
;     233 // Port D initialization
;     234 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     235 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     236 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     237 DDRD=0x00;
	OUT  0x11,R30
;     238 
;     239 // Timer/Counter 0 initializatio_n
;     240 // Clock source: System Clock
;     241 // Clock value: Timer 0 Stopped
;     242 // Mode: Normal top=FFh
;     243 // OC0 output: Disconnected
;     244 TCCR0=0x00;
	OUT  0x33,R30
;     245 TCNT0=0x00;
	OUT  0x32,R30
;     246 OCR0=0x00;
	OUT  0x3C,R30
;     247 
;     248 // Timer/Counter 1 initialization
;     249 // Clock source: System Clock
;     250 // Clock value: 2000,000 kHz
;     251 // Mode: CTC top=OCR1A
;     252 // OC1A output: Toggle
;     253 // OC1B output: Discon.
;     254 // Noise Canceler: Off
;     255 // Input Capture on Falling Edge
;     256 // Timer 1 Overflow Interrupt: Off
;     257 // Input Capture Interrupt: Off
;     258 // Compare A Match Interrupt: On
;     259 // Compare B Match Interrupt: Off
;     260 TCCR1A=0x40; // Configuration de la valeur de comparaison
	LDI  R30,LOW(64)
	OUT  0x2F,R30
;     261 TCCR1B=0x0A;
	LDI  R30,LOW(10)
	OUT  0x2E,R30
;     262 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     263 TCNT1L=0x00;
	OUT  0x2C,R30
;     264 ICR1H=0x00;
	OUT  0x27,R30
;     265 ICR1L=0x00;
	OUT  0x26,R30
;     266 OCR1AH=0x4E; // Slectionne la base de temps sur une frquence de 2 MHz, soit un top d'horloge toutes les 0,5 us.
	LDI  R30,LOW(78)
	OUT  0x2B,R30
;     267 OCR1AL=0x20; // Une interruption quand on arrive  20 000 top d'horloge (0x4E20 soit 10 ms)
	LDI  R30,LOW(32)
	OUT  0x2A,R30
;     268 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     269 OCR1BL=0x00;
	OUT  0x28,R30
;     270 
;     271 // Timer/Counter 2 initialization
;     272 // Clock source: System Clock
;     273 // Clock value: Timer 2 Stopped
;     274 // Mode: Normal top=FFh
;     275 // OC2 output: Disconnected
;     276 TCCR2=0x00;
	OUT  0x25,R30
;     277 TCNT2=0x00;
	OUT  0x24,R30
;     278 OCR2=0x00;
	OUT  0x23,R30
;     279 
;     280 
;     281 // External Interrupt(s) initialization
;     282 // INT0: On
;     283 // INT0 Mode: Falling Edge
;     284 // INT1: On
;     285 // INT1 Mode: Falling Edge
;     286 // INT2: Off
;     287 GICR|=0xC0;
	IN   R30,0x3B
	ORI  R30,LOW(0xC0)
	OUT  0x3B,R30
;     288 MCUCR=0x0A;
	LDI  R30,LOW(10)
	OUT  0x35,R30
;     289 MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
;     290 GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
;     291 
;     292 // Timer(s)/Counter(s) Interrupt(s) initialization
;     293 TIMSK=0x10;
	LDI  R30,LOW(16)
	OUT  0x39,R30
;     294 
;     295 // Analog Comparator initialization
;     296 // Analog Comparator: Off
;     297 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     298 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     299 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     300 
;     301 // USART initialization
;     302 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     303 // USART Receiver: On
;     304 // USART Transmitter: On                                               
;     305 // USART Mode: Asynchronous
;     306 // USART Baud rate: 9600
;     307 UCSRA=0x00;
	OUT  0xB,R30
;     308 UCSRB=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
;     309 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     310 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     311 UBRRL=0x67;
	LDI  R30,LOW(103)
	OUT  0x9,R30
;     312  
;     313 /* initialize the LCD for 2 lines & 16 columns */
;     314 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     315 
;     316 /* switch to writing in Display RAM */
;     317 //lcd_gotoxy(0,0);
;     318 //lcd_putsf("Projet Borne RFID"); 
;     319 
;     320 // initialisation des variables globales
;     321 Temps=0;
	RCALL SUBOPT_0x7
;     322 Seconde=0;
;     323 Minute=0;
;     324 Heure=0;
;     325 BUZZER=1;
	SBI  0x19,7
;     326 
;     327 // Global enable interrupts
;     328 #asm("sei")
	sei
;     329 
;     330 
;     331 while (1)
_0x36:
;     332 {
;     333     //Dclaration des variables locales
;     334     
;     335     unsigned char NumeroBorneHexa;
;     336     int Dizaine, Unite, NumeroBorne;
;     337     int PresenceCarte, z;
;     338     
;     339     // Appelle de L'horloge
;     340     Horloge();
	SBIW R28,11
;	NumeroBorneHexa -> Y+10
;	Dizaine -> Y+8
;	Unite -> Y+6
;	NumeroBorne -> Y+4
;	PresenceCarte -> Y+2
;	z -> Y+0
	RCALL _Horloge
;     341 
;     342     //Changement du numro de borne de 0  9
;     343     
;     344     NumeroBorneHexa = (PINA&0x0f);
	IN   R30,0x19
	ANDI R30,LOW(0xF)
	STD  Y+10,R30
;     345     /*Dizaine=NumeroBorneHexa/10;  	//Conversion du numro de bornes Hexadcimal en Dcimal
;     346     Unite=((int)NumeroBorneHexa)%10;
;     347     NumeroBorne=Dizaine*10+Unite;*/
;     348                  
;     349     sprintf(tampon,"N borne : 0x%x", NumeroBorneHexa);
	RCALL SUBOPT_0x1
	__POINTW1FN _0,39
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+14
	RCALL SUBOPT_0x5
	LDI  R24,4
	RCALL SUBOPT_0xD
;     350     lcd_gotoxy(0,0);   
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
;     351     lcd_puts(tampon);
	RCALL SUBOPT_0x1
	RCALL _lcd_puts
;     352      
;     353     //Vrification du statut de la carte
;     354     
;     355     PresenceCarte = VerifStatut ();   // Appelle de la fonction permettant de vrifier le statut
	RCALL _VerifStatut
	STD  Y+2,R30
	STD  Y+2+1,R31
;     356     
;     357     if(PresenceCarte==1)
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BREQ PC+2
	RJMP _0x39
;     358     {
;     359         /* Possiblit de lire l'identifiant unique de la carte     */
;     360         
;     361         Recoit_UID();
	RCALL _Recoit_UID
;     362         for(z=0;z<4;z++)
	LDI  R30,0
	STD  Y+0,R30
	STD  Y+0+1,R30
_0x3B:
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x4)
	LDI  R30,HIGH(0x4)
	CPC  R27,R30
	BRGE _0x3C
;     363         {
;     364         	sprintf(tampon,"%3d",Identifiant[z]);
	RCALL SUBOPT_0x1
	__POINTW1FN _0,54
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SUBI R30,LOW(-_Identifiant)
	SBCI R31,HIGH(-_Identifiant)
	LD   R30,Z
	RCALL SUBOPT_0x5
	LDI  R24,4
	RCALL SUBOPT_0xD
;     365         	lcd_gotoxy(z*4,1);   
	LD   R30,Y
	LDD  R31,Y+1
	RCALL __LSLW2
	ST   -Y,R30
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x6
;     366         	lcd_puts(tampon);
	RCALL SUBOPT_0x1
	RCALL _lcd_puts
;     367         }
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	RJMP _0x3B
_0x3C:
;     368         
;     369         // Ecriture du temps de passage sur la carte
;     370         
;     371         EcritureTemps(NumeroBorneHexa);
	LDD  R30,Y+10
	RCALL SUBOPT_0xA
	RCALL _EcritureTemps
;     372         
;     373         sprintf(tampon,"%x",Information);
	RCALL SUBOPT_0x1
	__POINTW1FN _0,51
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R6
	RCALL SUBOPT_0x5
	LDI  R24,4
	RCALL SUBOPT_0xD
;     374     	lcd_gotoxy(11,2);   
	LDI  R30,LOW(11)
	ST   -Y,R30
	RCALL SUBOPT_0x3
;     375     	lcd_puts(tampon);
	RCALL _lcd_puts
;     376         
;     377         //on attend 500 ms et on dclenche le buzzer pour marquer la fin de la lecture il faut faire attention de 
;     378         //ne pas figer l'affichage de l'horloge
;     379         
;     380         BUZZER=0;       //logique inverse
	CBI  0x19,7
;     381         
;     382         delay_ms(100);
	RCALL SUBOPT_0xE
;     383         Horloge();
;     384         
;     385         delay_ms(100);
	RCALL SUBOPT_0xE
;     386         Horloge();
;     387         
;     388         delay_ms(100);
	RCALL SUBOPT_0xE
;     389         Horloge();
;     390         
;     391         delay_ms(100);
	RCALL SUBOPT_0xE
;     392         Horloge();
;     393         
;     394         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     395         
;     396         BUZZER=1;        
	SBI  0x19,7
;     397     }
;     398 }
_0x39:
	ADIW R28,11
	RJMP _0x36
;     399 }
_0x3D:
	RJMP _0x3D
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G2:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G2:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G2)
	SBCI R31,HIGH(-__base_y_G2)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0xF
	LDD  R11,Y+1
	LDD  R12,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0xF
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0xF
	RCALL __lcd_ready
	LDI  R30,LOW(1)
	RCALL SUBOPT_0xF
	LDI  R30,LOW(0)
	MOV  R12,R30
	MOV  R11,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R11
	CP   R13,R11
	BRSH _0x3F
	__lcd_putchar1:
	INC  R12
	RCALL SUBOPT_0x2
	ST   -Y,R12
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x3F:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G2:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G2:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R13,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G2,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G2,3
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x10
	RCALL __long_delay_G2
	RCALL SUBOPT_0x11
	RCALL __lcd_init_write_G2
	RCALL __long_delay_G2
	LDI  R30,LOW(40)
	RCALL SUBOPT_0xF
	RCALL __long_delay_G2
	LDI  R30,LOW(4)
	RCALL SUBOPT_0xF
	RCALL __long_delay_G2
	LDI  R30,LOW(133)
	RCALL SUBOPT_0xF
	RCALL __long_delay_G2
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G2
	CPI  R30,LOW(0x5)
	BREQ _0x40
	LDI  R30,LOW(0)
	RJMP _0x9C
_0x40:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0xF
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x9C:
	ADIW R28,1
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0x12
	SBIW R30,0
	BREQ _0x41
	RCALL SUBOPT_0x12
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x42
_0x41:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x42:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x43:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x45
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x49
	CPI  R19,37
	BRNE _0x4A
	LDI  R16,LOW(1)
	RJMP _0x4B
_0x4A:
	RCALL SUBOPT_0x13
_0x4B:
	RJMP _0x48
_0x49:
	CPI  R30,LOW(0x1)
	BRNE _0x4C
	CPI  R19,37
	BRNE _0x4D
	RCALL SUBOPT_0x13
	LDI  R16,LOW(0)
	RJMP _0x48
_0x4D:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x4E
	LDI  R17,LOW(1)
	RJMP _0x48
_0x4E:
	CPI  R19,43
	BRNE _0x4F
	LDI  R21,LOW(43)
	RJMP _0x48
_0x4F:
	CPI  R19,32
	BRNE _0x50
	LDI  R21,LOW(32)
	RJMP _0x48
_0x50:
	RJMP _0x51
_0x4C:
	CPI  R30,LOW(0x2)
	BRNE _0x52
_0x51:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x53
	ORI  R17,LOW(128)
	RJMP _0x48
_0x53:
	RJMP _0x54
_0x52:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x48
_0x54:
	CPI  R19,48
	BRLO _0x57
	CPI  R19,58
	BRLO _0x58
_0x57:
	RJMP _0x56
_0x58:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x48
_0x56:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x5C
	RCALL SUBOPT_0x14
	LD   R30,X
	ST   -Y,R30
	RCALL SUBOPT_0x15
	RJMP _0x5D
_0x5C:
	CPI  R30,LOW(0x73)
	BRNE _0x5F
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x16
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x60
_0x5F:
	CPI  R30,LOW(0x70)
	BRNE _0x62
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x16
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x60:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x63
_0x62:
	CPI  R30,LOW(0x64)
	BREQ _0x66
	CPI  R30,LOW(0x69)
	BRNE _0x67
_0x66:
	ORI  R17,LOW(4)
	RJMP _0x68
_0x67:
	CPI  R30,LOW(0x75)
	BRNE _0x69
_0x68:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x6A
_0x69:
	CPI  R30,LOW(0x58)
	BRNE _0x6C
	ORI  R17,LOW(8)
	RJMP _0x6D
_0x6C:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x9B
_0x6D:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x6A:
	SBRS R17,2
	RJMP _0x6F
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x17
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x70
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x70:
	CPI  R21,0
	BREQ _0x71
	SUBI R16,-LOW(1)
	RJMP _0x72
_0x71:
	ANDI R17,LOW(251)
_0x72:
	RJMP _0x73
_0x6F:
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x17
_0x73:
_0x63:
	SBRC R17,0
	RJMP _0x74
_0x75:
	CP   R16,R20
	BRSH _0x77
	SBRS R17,7
	RJMP _0x78
	SBRS R17,2
	RJMP _0x79
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x7A
_0x79:
	LDI  R19,LOW(48)
_0x7A:
	RJMP _0x7B
_0x78:
	LDI  R19,LOW(32)
_0x7B:
	RCALL SUBOPT_0x13
	SUBI R20,LOW(1)
	RJMP _0x75
_0x77:
_0x74:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x7C
_0x7D:
	CPI  R18,0
	BREQ _0x7F
	SBRS R17,3
	RJMP _0x80
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x9E
_0x80:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x9E:
	ST   -Y,R30
	RCALL SUBOPT_0x15
	CPI  R20,0
	BREQ _0x82
	SUBI R20,LOW(1)
_0x82:
	SUBI R18,LOW(1)
	RJMP _0x7D
_0x7F:
	RJMP _0x83
_0x7C:
_0x85:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x87
	SBRS R17,3
	RJMP _0x88
	SUBI R19,-LOW(7)
	RJMP _0x89
_0x88:
	SUBI R19,-LOW(39)
_0x89:
_0x87:
	SBRC R17,4
	RJMP _0x8B
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x8D
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x8C
_0x8D:
	ORI  R17,LOW(16)
	RJMP _0x8F
_0x8C:
	CP   R20,R18
	BRLO _0x91
	SBRS R17,0
	RJMP _0x92
_0x91:
	RJMP _0x90
_0x92:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x93
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x8F:
	SBRS R17,2
	RJMP _0x94
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x15
	CPI  R20,0
	BREQ _0x95
	SUBI R20,LOW(1)
_0x95:
_0x94:
_0x93:
_0x8B:
	RCALL SUBOPT_0x13
	CPI  R20,0
	BREQ _0x96
	SUBI R20,LOW(1)
_0x96:
_0x90:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x86
	RJMP _0x85
_0x86:
_0x83:
	SBRS R17,0
	RJMP _0x97
_0x98:
	CPI  R20,0
	BREQ _0x9A
	SUBI R20,LOW(1)
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x15
	RJMP _0x98
_0x9A:
_0x97:
_0x9B:
_0x5D:
	LDI  R16,LOW(0)
_0x48:
	RJMP _0x43
_0x45:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	__PUTW2R 16,17
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x18
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x18
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL SUBOPT_0xC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	MOV  R4,R30
	ST   -Y,R4
	RCALL _USART_Transmit
	RCALL _USART_Receive
	MOV  R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(_tampon)
	LDI  R31,HIGH(_tampon)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _lcd_gotoxy
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(_Temps1)
	LDI  R31,HIGH(_Temps1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x5:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	CLR  R7
	CLR  R8
	CLR  R9
	CLR  R10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	MOV  R4,R30
	ST   -Y,R4
	RJMP _USART_Transmit

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x9:
	ST   -Y,R4
	RJMP _USART_Transmit

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xA:
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	RCALL __LOADLOCR2
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xD:
	RCALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	RJMP _Horloge

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0xF:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x10:
	RCALL __long_delay_G2
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDI  R30,LOW(32)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x13:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x14:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x15:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

