
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#asm
    .equ __lcd_port=0x15
#endasm

#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

unsigned char tampon[20], Temps1[20], Identifiant[8];
unsigned char trame, Statut;
unsigned char Temps, Seconde, Minute, Heure;

void USART_Transmit( unsigned char data )
{

while ( !( UCSRA & (0x20)) ) 
;

UDR = data;
}

unsigned char USART_Receive( void )
{

while ( !(UCSRA & 0x80) ) 
;

return UDR;
}

int VerifStatut (void)
{
int Presence;
while(PIND.4==1);     
trame='S';        
USART_Transmit(trame);
Statut = USART_Receive();

if(Statut==0x96)      
{
Presence=1;
sprintf(tampon,"Lecture  ");
lcd_gotoxy(0,2);
lcd_puts(tampon);
}
else
{
Presence=0;
sprintf(tampon,"Pas Carte");
lcd_gotoxy(0,2);
lcd_puts(tampon);
}
return Presence;   
}

void Recoit_UID (void)
{
int i;
unsigned char car;;
i=0;
while(PIND.4==1);
trame='U',     
USART_Transmit(trame);
Statut = USART_Receive();

while(i<=6)     
{
car = USART_Receive();
Identifiant[i]=car;
i++;
}
} 

interrupt [7] void timer1_compa_isr(void)
{  
Temps++;
if (Temps>=100) 
{
Temps=0;
Seconde++;
if(Seconde>=60) 
{
Seconde=0;
Minute++;
if(Minute>=60)
{
Minute=0;
Heure++;
if(Heure>=99)
{
Heure=0;
};
};
};
}; 
}

void Horloge(void)
{
sprintf(Temps1,"%2dh %2dmin %2ds", Heure, Minute, Seconde);
lcd_gotoxy(0,3);
lcd_puts(Temps1);
}

interrupt [3] void ext_int1_isr(void)
{
Temps=0;
Seconde=0;
Minute=0;
Heure=0;
}

interrupt [2] void ext_int0_isr(void) 
{ 

}    

void EcritureTemps(int Borne)
{
while(PIND.4==1);
trame='W',     
USART_Transmit(trame);

while(PIND.4==1);
trame=Borne,     
USART_Transmit(trame);

while(PIND.4==1);
trame=0x01;     
USART_Transmit(trame);

while(PIND.4==1);
trame=Temps;
USART_Transmit(trame);

while(PIND.4==1);
trame=Seconde;
USART_Transmit(trame);

while(PIND.4==1);
trame=Minute;
USART_Transmit(trame);

while(PIND.4==1);
trame=Heure;
USART_Transmit(trame);

}

void main(void)
{

PORTA=0x00;
DDRA=0xF0;

PORTB=0x00;
DDRB=0x00;

PORTC=0x00;
DDRC=0xFF;

PORTD=0x00;
DDRD=0x00;

TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

TCCR1A=0x40; 
TCCR1B=0x0A;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x4E; 
OCR1AL=0x20; 
OCR1BH=0x00;
OCR1BL=0x00;

TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

GICR|=0xC0;
MCUCR=0x0A;
MCUCSR=0x00;
GIFR=0xC0;

TIMSK=0x10;

ACSR=0x80;
SFIOR=0x00;

UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x67;

lcd_init(16);

Temps=0;
Seconde=0;
Minute=0;
Heure=0;
PINA.7=1;

#asm("sei")

while (1)
{

unsigned char NumeroBorneHexa;
int Dizaine, Unite, NumeroBorne;
int PresenceCarte;

Horloge();

NumeroBorneHexa = (PINA&0x0f);
Dizaine=NumeroBorneHexa/10;
Dizaine=Dizaine<<4;
Unite=((int)NumeroBorneHexa)%10;
NumeroBorne=Dizaine+Unite;

sprintf(tampon,"N borne : %2d",NumeroBorne);
lcd_gotoxy(0,0);   
lcd_puts(tampon);

PresenceCarte = VerifStatut ();   

if(PresenceCarte==1)
{

EcritureTemps(NumeroBorneHexa);

PINA.7=0;       

delay_ms(100);
Horloge();

delay_ms(100);
Horloge();

delay_ms(100);
Horloge();

delay_ms(100);
Horloge();

delay_ms(100);

PINA.7=1;        
}
}
}
